void PS4disconnect() {
  Usb.Task();


  if (PS4.connected()) {
    PS4.disconnect();
  }
}


void JoystickX_pos(int joystickvalue) {
  if (currentLEDcolor != 4 && ps4LEDmode == 0 && moveUactive == false && moveVactive == false && moveWactive == false && moveYactive == false && moveZactive == false) {
    currentLEDcolor = 4;
    PS4.setLed(0, 0, 255);
  }

  if (limitEnabledX == false) {
    if (micros() - prevMilliPS4x > decelerationSpeedxINT) {
      double speedXm = ((double)maxManualSpeedX) / ((double)255 - (double)137);
      double speedXb = -(double)speedXm * (double)137;
      speedXd = (joystickvalue * speedXm + speedXb ) * speedFactor;

      if (speedXps4 <= (int) speedXd) {
        speedXps4++;
      }
      if (speedXps4 > (int) speedXd) {
        speedXps4--;
      }
      AccelStepperX.setSpeed(speedXps4);
      moveXactive = true;
      prevMilliPS4x = micros();
    }

    AccelStepperX.runSpeed();
  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinX);
    //Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperX.currentPosition() < (limitStepsX - limitStepsXoffset)) {
        if (micros() - prevMilliPS4x > decelerationSpeedxINT) {
          double speedXm = ((double)maxManualSpeedX) / ((double)255 - (double)137);
          double speedXb = -(double)speedXm * (double)137;
          speedXd = (joystickvalue * speedXm + speedXb ) * speedFactor;

          if (speedXps4 <= (int) speedXd) {
            speedXps4++;
          }
          if (speedXps4 > (int) speedXd) {
            speedXps4--;
          }
          AccelStepperX.setSpeed(speedXps4);
          Serial.println(speedXps4);
          moveXactive = true;
          prevMilliPS4x = micros();
        }

        AccelStepperX.runSpeed();
      }
      else {
        speedXps4 = 0;
        speedXd = 0;
        limitXreached(0);
      }

    }
    else {
      switchhit = true;
      speedXps4 = 0;
      speedXd = 0;
      limitXreached(1);
    }
  }
}


void JoystickX_neg(int joystickvalue) {

  if (currentLEDcolor != 4 && ps4LEDmode == 0 && moveUactive == false && moveVactive == false && moveWactive == false && moveYactive == false && moveZactive == false) {
    currentLEDcolor = 4;
    PS4.setLed(0, 0, 255);
  }

  if (limitEnabledX == false) {
    if (micros() - prevMilliPS4x > decelerationSpeedxINT) {
      double speedXm = ((double)maxManualSpeedX) / ((double)255 - (double)137);
      double speedXb = -(double)speedXm * (double)137;
      speedXd = (joystickvalue * speedXm + speedXb ) * speedFactor;

      if (speedXps4 <= (int) speedXd) {
        speedXps4++;
      }
      if (speedXps4 > (int) speedXd) {
        speedXps4--;
      }
      AccelStepperX.setSpeed(speedXps4);
      Serial.println(speedXps4);
      moveXactive = true;
      prevMilliPS4x = micros();
    }

    AccelStepperX.runSpeed();
  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinX);
    //  Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperX.currentPosition() < (limitStepsX - limitStepsXoffset)) {


        if (micros() - prevMilliPS4x > decelerationSpeedxINT) {

          double speedXm = ( (double)maxManualSpeedX) / (double)(117);
          double speedXb = -(double)maxManualSpeedX;
          speedXd = (joystickvalue * speedXm + speedXb ) * speedFactor;
          if (speedXps4 <= (int) speedXd) {
            speedXps4++;
          }
          if (speedXps4 > (int) speedXd) {
            speedXps4--;
          }
          AccelStepperX.setSpeed(speedXps4);
          moveXactive = true;
          prevMilliPS4x = micros();
        }

        AccelStepperX.runSpeed();
      }
      else {
        speedXps4 = 0;
        speedXd = 0;
        limitXreached(0);
      }

    }
    else {
      switchhit = true;
      speedXps4 = 0;
      speedXd = 0;
      limitXreached(1);
    }
  }
}



void JoystickX_neutral() {
  if (moveXactive == true) {
    if (speedXps4 != 0) {
      if (speedXps4 > 0) {
        if ((micros() - prevMilliPS4x) >= decelerationSpeedxINT)
        {
          speedXps4--;
          AccelStepperX.setSpeed(speedXps4);

          prevMilliPS4x = micros();
        }
      }
      else {
        if ((micros() - prevMilliPS4x) >= decelerationSpeedxINT)
        {
          speedXps4++;
          AccelStepperX.setSpeed(speedXps4);

          prevMilliPS4x = micros();
        }
      }
      AccelStepperX.runSpeed();
    }

    if (ps4transmitdelayX == false && speedXps4 == 0) {
      ps4transmitdelayX = true;
      StringSend = "#curAxis_X$";
      Serial5.print(StringSend);
      transmitMillisX = millis();

    }


    if (millis() - transmitMillisX > 20 && speedXps4 == 0) {
      readBT(1010, "0");
      moveXactive = false;
      ps4transmitdelayX = false;

    }
  }
}


void JoystickZ_pos(int joystickvalue) {
  if (currentLEDcolor != 6 && ps4LEDmode == 0 && moveUactive == false && moveVactive == false && moveWactive == false && moveXactive == false && moveYactive == false) {
    currentLEDcolor = 6;
    PS4.setLed(255, 0, 0);
  }

  if (limitEnabledZ == false) {
    if (micros() - prevMilliPS4z > decelerationSpeedzINT) {
      double speedZm = ((double)maxManualSpeedZ) / ((double)255 - (double)137);
      double speedZb = -(double)speedZm * (double)137;
      speedZd = (joystickvalue * speedZm + speedZb ) * speedFactor;

      if (speedZps4 <= (int) speedZd) {
        speedZps4++;
      }
      if (speedZps4 > (int) speedZd) {
        speedZps4--;
      }
      AccelStepperZ.setSpeed(speedZps4);
      moveZactive = true;
      prevMilliPS4z = micros();
    }

    AccelStepperZ.runSpeed();
  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinZ);
    //Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperZ.currentPosition() < (limitStepsZ - limitStepsZoffset)) {
        if (micros() - prevMilliPS4z > decelerationSpeedzINT) {
          double speedZm = ((double)maxManualSpeedZ) / ((double)255 - (double)137);
          double speedZb = -(double)speedZm * (double)137;
          speedZd = (joystickvalue * speedZm + speedZb ) * speedFactor;

          if (speedZps4 <= (int) speedZd) {
            speedZps4++;
          }
          if (speedZps4 > (int) speedZd) {
            speedZps4--;
          }
          AccelStepperZ.setSpeed(speedZps4);
          Serial.println(speedZps4);
          moveZactive = true;
          prevMilliPS4z = micros();
        }

        AccelStepperZ.runSpeed();
      }
      else {
        speedZps4 = 0;
        speedZd = 0;
        limitZreached(0);
      }

    }
    else {
      switchhit = true;
      speedZps4 = 0;
      speedZd = 0;
      limitZreached(1);
    }
  }
}


void JoystickZ_neg(int joystickvalue) {

  if (currentLEDcolor != 6 && ps4LEDmode == 0 && moveUactive == false && moveVactive == false && moveWactive == false && moveXactive == false && moveYactive == false) {
    currentLEDcolor = 6;
    PS4.setLed(255, 0, 0);
  }

  if (limitEnabledZ == false) {
    if (micros() - prevMilliPS4z > decelerationSpeedzINT) {
      double speedZm = ((double)maxManualSpeedZ) / ((double)255 - (double)137);
      double speedZb = -(double)speedZm * (double)137;
      speedZd = (joystickvalue * speedZm + speedZb ) * speedFactor;

      if (speedZps4 <= (int) speedZd) {
        speedZps4++;
      }
      if (speedZps4 > (int) speedZd) {
        speedZps4--;
      }
      AccelStepperZ.setSpeed(speedZps4);
      Serial.println(speedZps4);
      moveZactive = true;
      prevMilliPS4z = micros();
    }

    AccelStepperZ.runSpeed();
  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinZ);
    //  Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperZ.currentPosition() < (limitStepsZ - limitStepsZoffset)) {


        if (micros() - prevMilliPS4z > decelerationSpeedzINT) {

          double speedZm = ( (double)maxManualSpeedZ) / (double)(117);
          double speedZb = -(double)maxManualSpeedZ;
          speedZd = (joystickvalue * speedZm + speedZb ) * speedFactor;
          if (speedZps4 <= (int) speedZd) {
            speedZps4++;
          }
          if (speedZps4 > (int) speedZd) {
            speedZps4--;
          }
          AccelStepperZ.setSpeed(speedZps4);
          moveZactive = true;
          prevMilliPS4z = micros();
        }

        AccelStepperZ.runSpeed();
      }
      else {
        speedZps4 = 0;
        speedZd = 0;
        limitZreached(0);
      }

    }
    else {
      switchhit = true;
      speedZps4 = 0;
      speedZd = 0;
      limitZreached(1);
    }
  }
}



void JoystickZ_neutral() {
  if (moveZactive == true) {
    if (speedZps4 != 0) {
      if (speedZps4 > 0) {
        if ((micros() - prevMilliPS4z) >= decelerationSpeedzINT)
        {
          speedZps4--;
          AccelStepperZ.setSpeed(speedZps4);

          prevMilliPS4z = micros();
        }
      }
      else {
        if ((micros() - prevMilliPS4z) >= decelerationSpeedzINT)
        {
          speedZps4++;
          AccelStepperZ.setSpeed(speedZps4);

          prevMilliPS4z = micros();
        }
      }
      AccelStepperZ.runSpeed();
    }

    if (ps4transmitdelayZ == false && speedZps4 == 0) {
      ps4transmitdelayZ = true;
      StringSend = "#curAxis_Z$";
      Serial5.print(StringSend);
      transmitMillisZ = millis();

    }


    if (millis() - transmitMillisZ > 20 && speedZps4 == 0) {
      readBT(1012, "0");
      moveZactive = false;
      ps4transmitdelayZ = false;

    }
  }
}


void JoystickW_pos(int joystickvalue) {
  if (currentLEDcolor != 3 && ps4LEDmode == 0 && moveUactive == false && moveVactive == false && moveXactive == false && moveXactive == false && moveZactive == false) {
    currentLEDcolor = 3;
    PS4.setLed(213, 0, 202);
  }

  if (limitEnabledW == false) {
    if (micros() - prevMilliPS4w > decelerationSpeedwINT) {
      double speedWm = ((double)maxManualSpeedW) / ((double)255 - (double)137);
      double speedWb = -(double)speedWm * (double)137;
      speedWd = (joystickvalue * speedWm + speedWb ) * speedFactor;

      if (speedWps4 <= (int) speedWd) {
        speedWps4++;
      }
      if (speedWps4 > (int) speedWd) {
        speedWps4--;
      }
      AccelStepperW.setSpeed(speedWps4);
      moveWactive = true;
      prevMilliPS4w = micros();
    }

    AccelStepperW.runSpeed();
  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinW);
    //Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperW.currentPosition() < (limitStepsW - limitStepsWoffset)) {
        if (micros() - prevMilliPS4w > decelerationSpeedwINT) {
          double speedWm = ((double)maxManualSpeedW) / ((double)255 - (double)137);
          double speedWb = -(double)speedWm * (double)137;
          speedWd = (joystickvalue * speedWm + speedWb ) * speedFactor;

          if (speedWps4 <= (int) speedWd) {
            speedWps4++;
          }
          if (speedWps4 > (int) speedWd) {
            speedWps4--;
          }
          AccelStepperW.setSpeed(speedWps4);
          Serial.println(speedWps4);
          moveWactive = true;
          prevMilliPS4w = micros();
        }

        AccelStepperW.runSpeed();
      }
      else {
        speedWps4 = 0;
        speedWd = 0;
        limitWreached(0);
      }

    }
    else {
      switchhit = true;
      speedWps4 = 0;
      speedWd = 0;
      limitWreached(1);
    }
  }
}


void JoystickW_neg(int joystickvalue) {

  if (currentLEDcolor != 3 && ps4LEDmode == 0 && moveUactive == false && moveVactive == false && moveXactive == false && moveXactive == false && moveZactive == false) {
    currentLEDcolor = 3;
    PS4.setLed(213, 0, 202);
  }

  if (limitEnabledW == false) {
    if (micros() - prevMilliPS4w > decelerationSpeedwINT) {
      double speedWm = ((double)maxManualSpeedW) / ((double)255 - (double)137);
      double speedWb = -(double)speedWm * (double)137;
      speedWd = (joystickvalue * speedWm + speedWb ) * speedFactor;

      if (speedWps4 <= (int) speedWd) {
        speedWps4++;
      }
      if (speedWps4 > (int) speedWd) {
        speedWps4--;
      }
      AccelStepperW.setSpeed(speedWps4);
      Serial.println(speedWps4);
      moveWactive = true;
      prevMilliPS4w = micros();
    }

    AccelStepperW.runSpeed();
  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinW);
    //  Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperW.currentPosition() < (limitStepsW - limitStepsWoffset)) {


        if (micros() - prevMilliPS4w > decelerationSpeedwINT) {

          double speedWm = ( (double)maxManualSpeedW) / (double)(117);
          double speedWb = -(double)maxManualSpeedW;
          speedWd = (joystickvalue * speedWm + speedWb ) * speedFactor;
          if (speedWps4 <= (int) speedWd) {
            speedWps4++;
          }
          if (speedWps4 > (int) speedWd) {
            speedWps4--;
          }
          AccelStepperW.setSpeed(speedWps4);
          moveWactive = true;
          prevMilliPS4w = micros();
        }

        AccelStepperW.runSpeed();
      }
      else {
        speedWps4 = 0;
        speedWd = 0;
        limitWreached(0);
      }

    }
    else {
      switchhit = true;
      speedWps4 = 0;
      speedWd = 0;
      limitWreached(1);
    }
  }
}



void JoystickW_neutral() {
  if (moveWactive == true) {
    if (speedWps4 != 0) {
      if (speedWps4 > 0) {
        if ((micros() - prevMilliPS4w) >= decelerationSpeedwINT)
        {
          speedWps4--;
          AccelStepperW.setSpeed(speedWps4);

          prevMilliPS4w = micros();
        }
      }
      else {
        if ((micros() - prevMilliPS4w) >= decelerationSpeedwINT)
        {
          speedWps4++;
          AccelStepperW.setSpeed(speedWps4);

          prevMilliPS4w = micros();
        }
      }
      AccelStepperW.runSpeed();
    }

    if (ps4transmitdelayW == false && speedWps4 == 0) {
      ps4transmitdelayW = true;
      StringSend = "#curAxis_W$";
      Serial5.print(StringSend);
      transmitMillisW = millis();

    }


    if (millis() - transmitMillisW > 20 && speedWps4 == 0) {
      readBT(1009, "0");
      moveWactive = false;
      ps4transmitdelayW = false;

    }
  }
}

void JoystickY_pos(int joystickvalue) {
  if (currentLEDcolor != 5 && ps4LEDmode == 0 && moveUactive == false && moveVactive == false && moveWactive == false && moveXactive == false && moveZactive == false) {
    currentLEDcolor = 5;
    PS4.setLed(255, 222, 0);
  }

  if (limitEnabledY == false) {
    if (micros() - prevMilliPS4y > decelerationSpeedyINT) {
      double speedYm = ((double)maxManualSpeedY) / ((double)255 - (double)137);
      double speedYb = -(double)speedYm * (double)137;
      speedYd = (joystickvalue * speedYm + speedYb ) * speedFactor;

      if (speedYps4 <= (int) speedYd) {
        speedYps4++;
      }
      if (speedYps4 > (int) speedYd) {
        speedYps4--;
      }
      AccelStepperY.setSpeed(speedYps4);
      moveYactive = true;
      prevMilliPS4y = micros();
    }

    AccelStepperY.runSpeed();
  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinY);
    //Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperY.currentPosition() < (limitStepsY - limitStepsYoffset)) {
        if (micros() - prevMilliPS4y > decelerationSpeedyINT) {
          double speedYm = ((double)maxManualSpeedY) / ((double)255 - (double)137);
          double speedYb = -(double)speedYm * (double)137;
          speedYd = (joystickvalue * speedYm + speedYb ) * speedFactor;

          if (speedYps4 <= (int) speedYd) {
            speedYps4++;
          }
          if (speedYps4 > (int) speedYd) {
            speedYps4--;
          }
          AccelStepperY.setSpeed(speedYps4);
          Serial.println(speedYps4);
          moveYactive = true;
          prevMilliPS4y = micros();
        }

        AccelStepperY.runSpeed();
      }
      else {
        speedYps4 = 0;
        speedYd = 0;
        limitYreached(0);
      }

    }
    else {
      switchhit = true;
      speedYps4 = 0;
      speedYd = 0;
      limitYreached(1);
    }
  }
}


void JoystickY_neg(int joystickvalue) {

  if (currentLEDcolor != 5 && ps4LEDmode == 0 && moveUactive == false && moveVactive == false && moveWactive == false && moveXactive == false && moveZactive == false) {
    currentLEDcolor = 5;
    PS4.setLed(255, 222, 0);
  }

  if (limitEnabledY == false) {
    if (micros() - prevMilliPS4y > decelerationSpeedyINT) {
      double speedYm = ((double)maxManualSpeedY) / ((double)255 - (double)137);
      double speedYb = -(double)speedYm * (double)137;
      speedYd = (joystickvalue * speedYm + speedYb ) * speedFactor;

      if (speedYps4 <= (int) speedYd) {
        speedYps4++;
      }
      if (speedYps4 > (int) speedYd) {
        speedYps4--;
      }
      AccelStepperY.setSpeed(speedYps4);
      Serial.println(speedYps4);
      moveYactive = true;
      prevMilliPS4y = micros();
    }

    AccelStepperY.runSpeed();
  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinY);
    //  Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperY.currentPosition() < (limitStepsY - limitStepsYoffset)) {


        if (micros() - prevMilliPS4y > decelerationSpeedyINT) {

          double speedYm = ( (double)maxManualSpeedY) / (double)(117);
          double speedYb = -(double)maxManualSpeedY;
          speedYd = (joystickvalue * speedYm + speedYb ) * speedFactor;
          if (speedYps4 <= (int) speedYd) {
            speedYps4++;
          }
          if (speedYps4 > (int) speedYd) {
            speedYps4--;
          }
          AccelStepperY.setSpeed(speedYps4);
          moveYactive = true;
          prevMilliPS4y = micros();
        }

        AccelStepperY.runSpeed();
      }
      else {
        speedYps4 = 0;
        speedYd = 0;
        limitYreached(0);
      }

    }
    else {
      switchhit = true;
      speedYps4 = 0;
      speedYd = 0;
      limitYreached(1);
    }
  }
}



void JoystickY_neutral() {
  if (moveYactive == true) {
    if (speedYps4 != 0) {
      if (speedYps4 > 0) {
        if ((micros() - prevMilliPS4y) >= decelerationSpeedyINT)
        {
          speedYps4--;
          AccelStepperY.setSpeed(speedYps4);

          prevMilliPS4y = micros();
        }
      }
      else {
        if ((micros() - prevMilliPS4y) >= decelerationSpeedyINT)
        {
          speedYps4++;
          AccelStepperY.setSpeed(speedYps4);

          prevMilliPS4y = micros();
        }
      }
      AccelStepperY.runSpeed();
    }

    if (ps4transmitdelayY == false && speedYps4 == 0) {
      ps4transmitdelayY = true;
      StringSend = "#curAxis_Y$";
      Serial5.print(StringSend);
      Serial.print("curAxis_Y$");
      Serial.println(StringSend);
      transmitMillisY = millis();

    }


    if (millis() - transmitMillisY > 20 && speedYps4 == 0) {
      readBT(1011, "0");
      moveYactive = false;
      ps4transmitdelayY = false;

    }
  }
}

void PS4controllerfunction () {


  Usb.Task();
  if (PS4.connected()) {
    if (moveKeyframe == false) {
      //------------------Joystick Left LEFT-RIGHT-------------------------
      if (PS4.getAnalogHat(LeftHatX) > 137) {

        if (joystickLeftMode == 1 || joystickLeftMode == 0) {
          // JoystickX_pos(PS4.getAnalogHat(LeftHatX));
          JoystickZ_pos(PS4.getAnalogHat(LeftHatX));

        }
      }

      if (PS4.getAnalogHat(LeftHatX) < 117) {
        if (joystickLeftMode == 1 || joystickLeftMode == 0 && ps4LEDmode == 0) {
          //  JoystickX_neg(PS4.getAnalogHat(LeftHatX));
          JoystickZ_neg(PS4.getAnalogHat(LeftHatX));
        }
      }

      if (PS4.getAnalogHat(LeftHatX) >= 117 && PS4.getAnalogHat(LeftHatX) <= 137) {
        //   JoystickX_neutral();
        JoystickZ_neutral();
      }

      //------------------Joystick Left UP-DOWN-------------------------
      if (PS4.getAnalogHat(LeftHatY) > 137) {


        if (joystickLeftMode == 2 || joystickLeftMode == 0) {
          JoystickW_pos(PS4.getAnalogHat(LeftHatY));
        }
      }

      if (PS4.getAnalogHat(LeftHatY) < 117) {
        if (joystickLeftMode == 2 || joystickLeftMode == 0) {
          JoystickW_neg(PS4.getAnalogHat(LeftHatY));

        }
      }

      if (PS4.getAnalogHat(LeftHatY) >= 117 && PS4.getAnalogHat(LeftHatY) <= 137) {
        JoystickW_neutral();
      }

      //------------------Joystick Right UP-DOWN-------------------------
      if (PS4.getAnalogHat(RightHatY) > 137) {
        if (joystickRightMode == 0 || joystickRightMode == 1) {

          JoystickX_pos(PS4.getAnalogHat(RightHatY));
        }
      }

      if (PS4.getAnalogHat(RightHatY) < 117) {
        if (joystickRightMode == 0 || joystickRightMode == 1) {

          JoystickX_neg(PS4.getAnalogHat(RightHatY));

        }
      }

      if (PS4.getAnalogHat(RightHatY) >= 117 && PS4.getAnalogHat(RightHatY) <= 137) {


        JoystickX_neutral();


      }

      //------------------Joystick Right LEFT-RIGHT-------------------------
      if (PS4.getAnalogHat(RightHatX) > 137) {
        if (joystickRightMode == 0 || joystickRightMode == 2) {

          JoystickY_pos(PS4.getAnalogHat(RightHatX));
        }
      }

      if (PS4.getAnalogHat(RightHatX) < 117) {
        if (joystickRightMode == 0 || joystickRightMode == 2) {
          JoystickY_neg(PS4.getAnalogHat(RightHatX));
        }
      }

      if (PS4.getAnalogHat(RightHatX) >= 117 && PS4.getAnalogHat(RightHatX) <= 137) {
        JoystickY_neutral();

      }

      //-----------------L2-Analog-Button---------------------------
      if (PS4.getAnalogButton(L2) > 0) {
        if (currentLEDcolor != 2 && ps4LEDmode == 0 && moveUactive == false && moveWactive == false && moveXactive == false && moveYactive == false && moveZactive == false) {
          currentLEDcolor = 2;
          PS4.setLed(79, 41, 0);
        }


        double speedVm = ( (double)maxManualSpeedV) / (double)(255);

        speedVd = (PS4.getAnalogButton(L2) * speedVm) * speedFactor;


        if (PS4.getButtonPress(L1)) {
          speedVd = -speedVd;
        }
        //  Serial.println(speedVd);

        if (micros() - prevMilliPS4v > decelerationSpeedvINT && speedVps4 < (int) speedVd) {
          prevMilliPS4v = micros();
          speedVps4++;
        }

        if (micros() - prevMilliPS4v > decelerationSpeedvINT && speedVps4 > (int) speedVd) {
          prevMilliPS4v = micros();
          speedVps4--;
        }



        AccelStepperV.setSpeed(speedVps4);
        //Serial.println(speedVps4);
        AccelStepperV.runSpeed();
        moveVactive = true;

      }



      if (PS4.getAnalogButton(L2) == 0 && moveVactive == true) {
        if (speedVps4 != 0) {
          if (speedVps4 > 0) {
            if ((micros() - prevMilliPS4v) >= decelerationSpeedvINT)
            {

              speedVps4--;

              prevMilliPS4v = micros();
            }
          }
          else {
            if ((micros() - prevMilliPS4v) >= decelerationSpeedvINT)
            {

              speedVps4++;

              prevMilliPS4v = micros();
            }
          }


          AccelStepperV.setSpeed(speedVps4);
          //  Serial.println(speedVps4);

          AccelStepperV.runSpeed();
        }

        if (ps4transmitdelayV == false && speedVps4 == 0) {
          ps4transmitdelayV = true;
          StringSend = "#curAxis_V$";
          Serial5.print(StringSend);
          transmitMillisV = millis();
        }


        if (millis() - transmitMillisV > 20 && speedVps4 == 0) {
          readBT(1008, "0");
          moveVactive = false;
          ps4transmitdelayV = false;
        }
      }



      //-----------------R2-Analog-Button---------------------------
      if (PS4.getAnalogButton(R2) > 0) {
        if (currentLEDcolor != 1 && ps4LEDmode == 0 && moveVactive == false && moveWactive == false && moveXactive == false && moveYactive == false && moveZactive == false) {
          currentLEDcolor = 1;
          PS4.setLed(0, 255, 0);
        }


        double speedUm = ( (double)maxManualSpeedU) / (double)(255);

        speedUd = (PS4.getAnalogButton(R2) * speedUm) * speedFactor;


        if (PS4.getButtonPress(R1)) {
          speedUd = -speedUd;
        }
        //  Serial.println(speedUd);

        if (micros() - prevMilliPS4u > decelerationSpeeduINT && speedUps4 < (int) speedUd) {
          prevMilliPS4u = micros();
          speedUps4++;
        }

        if (micros() - prevMilliPS4u > decelerationSpeeduINT && speedUps4 > (int) speedUd) {
          prevMilliPS4u = micros();
          speedUps4--;
        }



        AccelStepperU.setSpeed(speedUps4);
        //Serial.println(speedUps4);
        AccelStepperU.runSpeed();
        moveUactive = true;

      }



      if (PS4.getAnalogButton(R2) == 0 && moveUactive == true) {
        if (speedUps4 != 0) {
          if (speedUps4 > 0) {
            if ((micros() - prevMilliPS4u) >= decelerationSpeeduINT)
            {

              speedUps4--;

              prevMilliPS4u = micros();
            }
          }
          else {
            if ((micros() - prevMilliPS4u) >= decelerationSpeeduINT)
            {

              speedUps4++;

              prevMilliPS4u = micros();
            }
          }


          AccelStepperU.setSpeed(speedUps4);
          //  Serial.println(speedUps4);

          AccelStepperU.runSpeed();
        }

        if (ps4transmitdelayU == false && speedUps4 == 0) {
          ps4transmitdelayU = true;
          StringSend = "#curAxis_U$";
          Serial5.print(StringSend);
          transmitMillisU = millis();
        }


        if (millis() - transmitMillisU > 20 && speedUps4 == 0) {
          readBT(1007, "0");
          moveUactive = false;
          ps4transmitdelayU = false;
        }
      }


      //--------TRIANGLE------------------
      if (PS4.getButtonClick(TRIANGLE)) {
        switch (ps4LEDmode) {
          case 0:
            PS4.setLed(0, 0, 0);
            ps4LEDmode = 1;
            break;
          case 1:
            PS4.setLed(255, 255, 255);
            ps4LEDmode = 2;
            break;
          case 2:
            PS4.setLed(0, 0, 255);
            ps4LEDmode = 0;
            break;
        }

        myString = String(ps4LEDmode);;
        StringSend = "#ps4tri_" + myString + "$";
        Serial5.print(StringSend);
      }
      //--------PS------------------
      if (PS4.getButtonClick(PS)) {
        //  Serial.print(F("\r\nPS"));
        PS4.disconnect();
        Serial.println("PS4disconnect8");

      }

      //--------CIRCLE------------------
      if (PS4.getButtonClick(CIRCLE)) {
        // Serial.print(F("\r\nCircle"));
        // PS4.setRumbleOn(RumbleHigh);


        if (speedFactor < 0.9) {
          speedFactor = 1;
          myString = "1";
        }
        else {

          speedFactor = 0.2;
          myString = "0";
        }

        StringSend = "#ps4circ_" + myString + "$";
        Serial5.print(StringSend);
      }
      //--------CROSS------------------
      if (PS4.getButtonClick(CROSS)) {
        StringSend = "#trigcam_0$";
        Serial5.print(StringSend);

        // PS4.setLedFlash(10, 10); // Set it to blink rapidly
      }
      //--------SQUARE------------------
      if (PS4.getButtonClick(SQUARE)) {

      }
      //--------UP------------------
      if (PS4.getButtonClick(UP)) {
        StringSend = "#addmovekf_0$";
        Serial5.print(StringSend);
      }
      //--------RIGHT------------------
      if (PS4.getButtonClick(RIGHT)) {
        StringSend = "#nextkey_0$";
        Serial5.print(StringSend);
      }
      //--------DOWN------------------
      if (PS4.getButtonClick(DOWN)) {
 StringSend = "#removekf_0$";
        Serial5.print(StringSend);
      }

      //--------LEFT------------------
      if (PS4.getButtonClick(LEFT)) {
        StringSend = "#prevkey_0$";
        Serial5.print(StringSend);
        //PS4.setLed(Green);
      }

      //-----------------L3-Button----------------------
      if (PS4.getButtonClick(L3)) {

        switch (joystickLeftMode) {
          case 0:
            joystickLeftMode = 1;
            break;

          case 1:
            joystickLeftMode = 2;
            break;

          case 2:
            joystickLeftMode = 0;
            break;
        }
      }

      //-----------------R3-Button----------------------

      if (PS4.getButtonClick(R3)) {

        switch (joystickRightMode) {
          case 0:
            joystickRightMode = 1;
            break;

          case 1:
            joystickRightMode = 2;
            break;

          case 2:
            joystickRightMode = 0;
            break;
        }
      }

      //------------------SHARE-Button--------------------------
      //------------------Transmit battery status---------------
      if (PS4.getButtonClick(SHARE)) {
        readBT(5200, "0");
      }

      if (PS4.getButtonClick(OPTIONS)) {
        //  Serial.print(F("\r\nOptions"));
     //   printAngle = !printAngle;
      }
      if (PS4.getButtonClick(TOUCHPAD)) {
        //  Serial.print(F("\r\nTouchpad"));
        //  printTouch = !printTouch;
      }

      if (printAngle) { // Print angle calculated using the accelerometer only


        speedX = PS4.getAngle(Roll) * -79.667 + 14016;
        AccelStepperX.setSpeed(speedX);
        AccelStepperX.runSpeed();

        speedY = PS4.getAngle(Pitch) * -43.725 + 6923;
        AccelStepperY.setSpeed(speedY);
        //   Serial.println("1111117");
        AccelStepperY.runSpeed();

      }






      if (PS4.isTouching(0)) { // Print the position of the finger if it is touching the touchpad
        touchactive = false;
        if ((millis() - prevTimePStouch) > 100) {
          myString = String(PS4.getX(0));
          StringSend = "#xtouch_" + myString + "$";
          Serial5.print(StringSend);
          prevTimePStouch = millis();
          Serial.println(myString);

        }
        /*
                      speedX = PS4.getX(i) * 0.5319 - 510.64;
                      AccelStepperX.setSpeed(speedX);
                      AccelStepperX.runSpeed();

                      speedY = PS4.getY(i) * -1.0753 + 510.75;
                      AccelStepperY.setSpeed(speedY);
                      AccelStepperY.runSpeed();
        */

      }
      else if (touchactive == false) {
        StringSend = "#xtouch_950$";
        Serial5.print(StringSend);
        prevTimePStouch = millis();
        Serial.println(StringSend);
        touchactive = true;
      }





    }
  }

}


void limitXreached(int limitswitch) {
  switchreached = false;
  AccelStepperX.stop();
  StringSend = "#limitx_0$";
  Serial5.print(StringSend);
  // Serial.println(StringSend);
  long prevmill;
  long newPosiii = limitStepsX - limitStepsXoffset - limitBackOffX;
  if (limitswitch == 1) {
    newPosiii = AccelStepperX.currentPosition() + limitBackOffX;
  }
  while (switchreached == false) {

    AccelStepperX.moveTo(newPosiii);
    AccelStepperX.run();

    if (AccelStepperX.currentPosition() == newPosiii) {
      switchreached = true;
      //  Serial.println("reaaaaach");
      reachedtime = millis();
    }

  }
  runX = 0;
  currentSpeedX = 0;
  switchhit = false;
}

void limitZreached(int limitswitch) {
  switchreached = false;
  AccelStepperZ.stop();
  StringSend = "#limitz_0$";
  Serial5.print(StringSend);
  // Serial.println(StringSend);
  long prevmill;
  long newPosiii = limitStepsZ - limitStepsZoffset - limitBackOffZ;
  if (limitswitch == 1) {
    newPosiii = AccelStepperZ.currentPosition() + limitBackOffZ;
  }
  while (switchreached == false) {

    AccelStepperZ.moveTo(newPosiii);
    AccelStepperZ.run();

    if (AccelStepperZ.currentPosition() == newPosiii) {
      switchreached = true;
      //  Serial.println("reaaaaach");
      reachedtime = millis();
    }

  }
  runZ = 0;
  currentSpeedZ = 0;
  switchhit = false;
}

void limitWreached(int limitswitch) {
  switchreached = false;
  AccelStepperW.stop();
  StringSend = "#limitw_0$";
  Serial5.print(StringSend);
  // Serial.println(StringSend);
  long prevmill;
  long newPosiii = limitStepsW - limitStepsWoffset - limitBackOffW;
  if (limitswitch == 1) {
    newPosiii = AccelStepperW.currentPosition() + limitBackOffW;
  }
  while (switchreached == false) {

    AccelStepperW.moveTo(newPosiii);
    AccelStepperW.run();

    if (AccelStepperW.currentPosition() == newPosiii) {
      switchreached = true;
      //  Serial.println("reaaaaach");
      reachedtime = millis();
    }

  }
  runW = 0;
  currentSpeedW = 0;
  switchhit = false;
}

void limitYreached(int limitswitch) {
  switchreached = false;
  AccelStepperY.stop();
  StringSend = "#limity_0$";
  Serial5.print(StringSend);
  // Serial.println(StringSend);
  long prevmill;
  long newPosiii = limitStepsY - limitStepsYoffset - limitBackOffY;
  if (limitswitch == 1) {
    newPosiii = AccelStepperY.currentPosition() + limitBackOffY;
  }
  while (switchreached == false) {

    AccelStepperY.moveTo(newPosiii);
    AccelStepperY.run();

    if (AccelStepperY.currentPosition() == newPosiii) {
      switchreached = true;
      //  Serial.println("reaaaaach");
      reachedtime = millis();
    }

  }
  runY = 0;
  currentSpeedY = 0;
  switchhit = false;
}
