//---------Input---------

void softwarejoystickinput(byte axis, byte joyvalue) {

Serial.println(axis);
Serial.println(joyvalue);
  switch (axis) {

    //----------U axis----------
    case 1:
      if (joyvalue < 49) {
        softJoystickUactive = true;
        joystickSpeedU = (- (double)maxManualSpeedU / (double)48) * (double)joyvalue + (double)maxManualSpeedU;
        joystickSpeedU = -joystickSpeedU;
      }
      else if (joyvalue > 51) {
        softJoystickUactive = true;
        joystickSpeedU = (((double)maxManualSpeedU / (double)48) * (double)joyvalue) - (((double)maxManualSpeedU / (double)48) * (double)52);
      }
      else {
        joystickSpeedU = 0;
      }

      joystickSpeedUINT = (int) joystickSpeedU;
      runU = 2;
      break;
    //----------V axis----------
    case 2:
      if (joyvalue < 49) {
        softJoystickVactive = true;
        joystickSpeedV = (- (double)maxManualSpeedV / (double)48) * (double)joyvalue + (double)maxManualSpeedV;
        joystickSpeedV = -joystickSpeedV;
      }
      else if (joyvalue > 51) {
        softJoystickVactive = true;
        joystickSpeedV = (((double)maxManualSpeedV / (double)48) * (double)joyvalue) - (((double)maxManualSpeedV / (double)48) * (double)52);
      }
      else {
        joystickSpeedV = 0;
      }

      joystickSpeedVINT = (int) joystickSpeedV;
      runV = 2;
      break;
    //----------W axis----------
    case 3:
      if (joyvalue < 49) {
        softJoystickWactive = true;
        joystickSpeedW = (- (double)maxManualSpeedW / (double)48) * (double)joyvalue + (double)maxManualSpeedW;
        joystickSpeedW = -joystickSpeedW;
      }
      else if (joyvalue > 51) {
        softJoystickWactive = true;
        joystickSpeedW = (((double)maxManualSpeedW / (double)48) * (double)joyvalue) - (((double)maxManualSpeedW / (double)48) * (double)52);
      }
      else {
        joystickSpeedW = 0;
      }

      joystickSpeedWINT = (int) joystickSpeedW;
      runW = 2;
      break;
    //----------X axis----------
    case 4:
      if (joyvalue < 49) {
        softJoystickXactive = true;
        joystickSpeedX = (- (double)maxManualSpeedX / (double)48) * (double)joyvalue + (double)maxManualSpeedX;
        joystickSpeedX = -joystickSpeedX;
      }
      else if (joyvalue > 51) {
        softJoystickXactive = true;
        joystickSpeedX = (((double)maxManualSpeedX / (double)48) * (double)joyvalue) - (((double)maxManualSpeedX / (double)48) * (double)52);
      }
      else {
        joystickSpeedX = 0;
      }

      joystickSpeedXINT = (int) joystickSpeedX;
      runX = 2;
      break;
    //----------Y axis----------
    case 5:
      if (joyvalue < 49) {
        softJoystickYactive = true;

        joystickSpeedY = (- (double)maxManualSpeedY / (double)48) * (double)joyvalue + (double)maxManualSpeedY;
        joystickSpeedY = -joystickSpeedY;
      }
      else if (joyvalue > 51) {
        softJoystickYactive = true;

        joystickSpeedY = (((double)maxManualSpeedY / (double)48) * (double)joyvalue) - (((double)maxManualSpeedY / (double)48) * (double)52);
      }
      else {

        joystickSpeedY = 0;
      }

      joystickSpeedYINT = (int) joystickSpeedY;
      runY = 2;

      break;
    //----------Z axis----------
    case 6:
     if (joyvalue < 49) {
        softJoystickZactive = true;
        joystickSpeedZ = (- (double)maxManualSpeedZ / (double)48) * (double)joyvalue + (double)maxManualSpeedZ;
        joystickSpeedZ = -joystickSpeedZ;
      }
      else if (joyvalue > 51) {
        softJoystickZactive = true;
        joystickSpeedZ = (((double)maxManualSpeedZ / (double)48) * (double)joyvalue) - (((double)maxManualSpeedZ / (double)48) * (double)52);
      }
      else {
        joystickSpeedZ = 0;
      }

      joystickSpeedZINT = (int) joystickSpeedZ;
      runZ = 2;
      break;



  }



}

//---------U-axis ---------
void softJoystickU(int joystickvalue) {


  if (limitEnabledU == false) {
    if (micros() - prevMilliPS4u > decelerationSpeeduINT) {

      if (speedUps4 <= joystickvalue) {
        speedUps4++;
      }
      if (speedUps4 > joystickvalue) {
        speedUps4--;
      }

      currentSpeedU = speedUps4;
      moveUactive = true;
      prevMilliPS4u = micros();


      if (speedUps4 == 0 && joystickvalue == 0) {
        softJoystickUactive = false;
        runU = 0;
      }
    }

  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinX);
    //Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperX.currentPosition() < (limitStepsX - limitStepsXoffset)) {
        if (micros() - prevMilliPS4x > decelerationSpeedxINT) {
          double speedXm = ((double)maxManualSpeedX) / ((double)255 - (double)137);
          double speedXb = -(double)speedXm * (double)137;
          speedXd = (joystickvalue * speedXm + speedXb ) * speedFactor;

          if (speedXps4 <= (int) speedXd) {
            speedXps4++;
          }
          if (speedXps4 > (int) speedXd) {
            speedXps4--;
          }
          currentSpeedX = speedXps4;

          moveXactive = true;
          prevMilliPS4x = micros();
        }


      }
      else {
        speedXps4 = 0;
        speedXd = 0;
        limitXreached(0);
      }

    }
    else {
      switchhit = true;
      speedXps4 = 0;
      speedXd = 0;
      limitXreached(1);
    }
  }
}

//---------V-axis ---------
void softJoystickV(int joystickvalue) {


  if (limitEnabledV == false) {
    if (micros() - prevMilliPS4v > decelerationSpeedvINT) {

      if (speedVps4 <= joystickvalue) {
        speedVps4++;
      }
      if (speedVps4 > joystickvalue) {
        speedVps4--;
      }

      currentSpeedV = speedVps4;
      moveVactive = true;
      prevMilliPS4v = micros();


      if (speedVps4 == 0 && joystickvalue == 0) {
        softJoystickVactive = false;
        runV = 0;
      }
    }

  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinX);
    //Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperX.currentPosition() < (limitStepsX - limitStepsXoffset)) {
        if (micros() - prevMilliPS4x > decelerationSpeedxINT) {
          double speedXm = ((double)maxManualSpeedX) / ((double)255 - (double)137);
          double speedXb = -(double)speedXm * (double)137;
          speedXd = (joystickvalue * speedXm + speedXb ) * speedFactor;

          if (speedXps4 <= (int) speedXd) {
            speedXps4++;
          }
          if (speedXps4 > (int) speedXd) {
            speedXps4--;
          }
          currentSpeedX = speedXps4;

          moveXactive = true;
          prevMilliPS4x = micros();
        }


      }
      else {
        speedXps4 = 0;
        speedXd = 0;
        limitXreached(0);
      }

    }
    else {
      switchhit = true;
      speedXps4 = 0;
      speedXd = 0;
      limitXreached(1);
    }
  }
}

//---------W-axis ---------
void softJoystickW(int joystickvalue) {


  if (limitEnabledW == false) {
    if (micros() - prevMilliPS4w > decelerationSpeedwINT) {

      if (speedWps4 <= joystickvalue) {
        speedWps4++;
      }
      if (speedWps4 > joystickvalue) {
        speedWps4--;
      }

      currentSpeedW = speedWps4;
      moveWactive = true;
      prevMilliPS4w = micros();


      if (speedWps4 == 0 && joystickvalue == 0) {
        softJoystickWactive = false;
        runW = 0;
      }
    }

  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinX);
    //Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperX.currentPosition() < (limitStepsX - limitStepsXoffset)) {
        if (micros() - prevMilliPS4x > decelerationSpeedxINT) {
          double speedXm = ((double)maxManualSpeedX) / ((double)255 - (double)137);
          double speedXb = -(double)speedXm * (double)137;
          speedXd = (joystickvalue * speedXm + speedXb ) * speedFactor;

          if (speedXps4 <= (int) speedXd) {
            speedXps4++;
          }
          if (speedXps4 > (int) speedXd) {
            speedXps4--;
          }
          currentSpeedX = speedXps4;

          moveXactive = true;
          prevMilliPS4x = micros();
        }


      }
      else {
        speedXps4 = 0;
        speedXd = 0;
        limitXreached(0);
      }

    }
    else {
      switchhit = true;
      speedXps4 = 0;
      speedXd = 0;
      limitXreached(1);
    }
  }
}

//---------X-axis ---------
void softJoystickX(int joystickvalue) {


  if (limitEnabledX == false) {
    if (micros() - prevMilliPS4x > decelerationSpeedxINT) {

      if (speedXps4 <= joystickvalue) {
        speedXps4++;
      }
      if (speedXps4 > joystickvalue) {
        speedXps4--;
      }

      currentSpeedX = speedXps4;
      moveXactive = true;
      prevMilliPS4x = micros();


      if (speedXps4 == 0 && joystickvalue == 0) {
        softJoystickXactive = false;
        runX = 0;
      }
    }

  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinX);
    //Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperX.currentPosition() < (limitStepsX - limitStepsXoffset)) {
        if (micros() - prevMilliPS4x > decelerationSpeedxINT) {
          double speedXm = ((double)maxManualSpeedX) / ((double)255 - (double)137);
          double speedXb = -(double)speedXm * (double)137;
          speedXd = (joystickvalue * speedXm + speedXb ) * speedFactor;

          if (speedXps4 <= (int) speedXd) {
            speedXps4++;
          }
          if (speedXps4 > (int) speedXd) {
            speedXps4--;
          }
          currentSpeedX = speedXps4;

          moveXactive = true;
          prevMilliPS4x = micros();
        }


      }
      else {
        speedXps4 = 0;
        speedXd = 0;
        limitXreached(0);
      }

    }
    else {
      switchhit = true;
      speedXps4 = 0;
      speedXd = 0;
      limitXreached(1);
    }
  }
}



//---------------------Y axis---------------------

void softJoystickY(int joystickvalue) {


  if (limitEnabledY == false) {
    if (micros() - prevMilliPS4y > decelerationSpeedyINT) {

      if (speedYps4 <= joystickvalue) {
        speedYps4++;
      }
      if (speedYps4 > joystickvalue) {
        speedYps4--;
      }

      currentSpeedY = speedYps4;
      moveYactive = true;
      prevMilliPS4y = micros();

      if (speedYps4 == 0 && joystickvalue == 0) {
        softJoystickYactive = false;
        runY = 0;
      }
    }

  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinY);
    //Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperY.currentPosition() < (limitStepsY - limitStepsYoffset)) {
        if (micros() - prevMilliPS4y > decelerationSpeedyINT) {
          double speedYm = ((double)maxManualSpeedY) / ((double)255 - (double)137);
          double speedYb = -(double)speedYm * (double)137;
          speedYd = (joystickvalue * speedYm + speedYb ) * speedFactor;

          if (speedYps4 <= (int) speedYd) {
            speedYps4++;
          }
          if (speedYps4 > (int) speedYd) {
            speedYps4--;
          }
          currentSpeedY = speedYps4;

          moveYactive = true;
          prevMilliPS4y = micros();
        }


      }
      else {
        speedYps4 = 0;
        speedYd = 0;
        limitYreached(0);
      }

    }
    else {
      switchhit = true;
      speedYps4 = 0;
      speedYd = 0;
      limitYreached(1);
    }
  }
}

//---------Z-axis ---------
void softJoystickZ(int joystickvalue) {


  if (limitEnabledZ == false) {
    if (micros() - prevMilliPS4z > decelerationSpeedzINT) {

      if (speedZps4 <= joystickvalue) {
        speedZps4++;
      }
      if (speedZps4 > joystickvalue) {
        speedZps4--;
      }

      currentSpeedZ = speedZps4;
      moveZactive = true;
      prevMilliPS4z = micros();


      if (speedZps4 == 0 && joystickvalue == 0) {
        softJoystickZactive = false;
        runZ = 0;
      }
    }

  }
  else if ((millis() - reachedtime) > 3200) {
    int buttonState = digitalRead(limitSwitchPinZ);
    //Serial.println(buttonState);
    if (buttonState == 0 && switchhit == false) {
      if (AccelStepperZ.currentPosition() < (limitStepsZ - limitStepsZoffset)) {
        if (micros() - prevMilliPS4z > decelerationSpeedzINT) {
          double speedZm = ((double)maxManualSpeedZ) / ((double)255 - (double)137);
          double speedZb = -(double)speedZm * (double)137;
          speedZd = (joystickvalue * speedZm + speedZb ) * speedFactor;

          if (speedZps4 <= (int) speedZd) {
            speedZps4++;
          }
          if (speedZps4 > (int) speedZd) {
            speedZps4--;
          }
          currentSpeedZ = speedZps4;

          moveZactive = true;
          prevMilliPS4z = micros();
        }


      }
      else {
        speedZps4 = 0;
        speedZd = 0;
        limitZreached(0);
      }

    }
    else {
      switchhit = true;
      speedZps4 = 0;
      speedZd = 0;
      limitXreached(1);
    }
  }
}
