void autorefrun() {
  if (autoRefRunU == true) {
    runtoswitch(1, limitSwitchPinU, limitBackOffU);
  }
  if (autoRefRunV == true) {
    runtoswitch(2, limitSwitchPinV, limitBackOffV);
  }
  if (autoRefRunW == true) {
    runtoswitch(3, limitSwitchPinW, limitBackOffW);
  }
  if (autoRefRunX == true) {
    Serial.println("autoRefRunrunrunX");
    runtoswitch(4, limitSwitchPinX, limitBackOffX);
  }
  if (autoRefRunY == true) {
    runtoswitch(5, limitSwitchPinY, limitBackOffY);
  }
  if (autoRefRunZ == true) {
    runtoswitch(6, limitSwitchPinZ, limitBackOffZ);
  }
  delay(50);
  StringSend = "#refRunFinished_0$";
  Serial5.print(StringSend);
  Serial.println(StringSend);
}

void runtoswitch(int axis, int inputpin, long backoffdistance) {

  pinMode(inputpin, INPUT_PULLDOWN);
  delay(50);
  int buttonState;

  switch (axis) {

    //----------------U-axis----------------
    case 1:
      AccelStepperU.setCurrentPosition(0);
      AccelStepperU.setMaxSpeed(speedU);
      AccelStepperU.setAcceleration(speedU / 2);
      AccelStepperU.moveTo(-9999999);
      buttonState = digitalRead(inputpin);

      while (buttonState == 0) {
        buttonState = digitalRead(inputpin);
        AccelStepperU.run();

      }
      AccelStepperU.stop();
      AccelStepperU.setCurrentPosition(0);
      AccelStepperU.moveTo(backoffdistance);
      AccelStepperU.run();

      while (AccelStepperU.currentPosition() != AccelStepperU.targetPosition()) {

        AccelStepperU.run();

      }
      AccelStepperU.setCurrentPosition(0);
      AccelStepperU.run();

      StringSend = "#refPosU_1$";
      Serial5.print(StringSend);
      break;
    //----------------V-axis----------------
    case 2:
      AccelStepperV.setCurrentPosition(0);
      AccelStepperV.setMaxSpeed(speedV);
      AccelStepperV.setAcceleration(speedV / 2);
      AccelStepperV.moveTo(-9999999);
      buttonState = digitalRead(inputpin);

      while (buttonState == 0) {
        buttonState = digitalRead(inputpin);
        AccelStepperV.run();

      }
      AccelStepperV.stop();
      AccelStepperV.setCurrentPosition(0);
      AccelStepperV.moveTo(backoffdistance);
      AccelStepperV.run();

      while (AccelStepperV.currentPosition() != AccelStepperV.targetPosition()) {

        AccelStepperV.run();

      }
      AccelStepperV.setCurrentPosition(0);
      AccelStepperV.run();
      StringSend = "#refPosV_1$";
      Serial5.print(StringSend);
      break;
    //----------------W-axis----------------
    case 3:
      AccelStepperW.setCurrentPosition(0);
      AccelStepperW.setMaxSpeed(speedW);
      AccelStepperW.setAcceleration(speedW / 2);
      AccelStepperW.moveTo(-9999999);
      buttonState = digitalRead(inputpin);

      while (buttonState == 0) {
        buttonState = digitalRead(inputpin);
        AccelStepperW.run();

      }
      AccelStepperW.stop();
      AccelStepperW.setCurrentPosition(0);
      AccelStepperW.moveTo(backoffdistance);
      AccelStepperW.run();

      while (AccelStepperW.currentPosition() != AccelStepperW.targetPosition()) {

        AccelStepperW.run();

      }
      AccelStepperW.setCurrentPosition(0);
      AccelStepperW.run();
      StringSend = "#refPosW_1$";
      Serial5.print(StringSend);
      break;

    //----------------X-axis----------------
    case 4:
      AccelStepperX.setCurrentPosition(0);
      AccelStepperX.setMaxSpeed(speedX);
      AccelStepperX.setAcceleration(speedX / 2);
      AccelStepperX.moveTo(-9999999);
      Serial.println("moveX");
      buttonState = digitalRead(inputpin);

      while (buttonState == 0) {
        buttonState = digitalRead(inputpin);
       // Serial.println(buttonState);
        AccelStepperX.run();

      }
      AccelStepperX.stop();
      AccelStepperX.setCurrentPosition(0);
      AccelStepperX.moveTo(backoffdistance);
      AccelStepperX.run();

      while (AccelStepperX.currentPosition() != AccelStepperX.targetPosition()) {

        AccelStepperX.run();

      }
      AccelStepperX.setCurrentPosition(0);
      AccelStepperX.run();
      StringSend = "#refPosX_1$";
      Serial5.print(StringSend);
      break;
    //----------------Y-axis----------------
    case 5:
      pinMode(inputpin, INPUT_PULLDOWN);
      delay(50);
      AccelStepperY.setCurrentPosition(0);
      AccelStepperY.setMaxSpeed(speedY);
      AccelStepperY.setAcceleration(speedY / 2);
      AccelStepperY.moveTo(-9999999);
      buttonState = digitalRead(inputpin);

      while (buttonState == 0) {
        buttonState = digitalRead(inputpin);
        /*
        Serial.print("buttonY: ");
        Serial.print(inputpin);
        Serial.print(":");
        Serial.println(buttonState);
*/
        AccelStepperY.run();

      }
      AccelStepperY.stop();
      AccelStepperY.setCurrentPosition(0);
      AccelStepperY.moveTo(backoffdistance);
      AccelStepperY.run();

      while (AccelStepperY.currentPosition() != AccelStepperY.targetPosition()) {

        AccelStepperY.run();

      }
      AccelStepperY.setCurrentPosition(0);
      AccelStepperY.run();
      StringSend = "#refPosY_1$";
      Serial5.print(StringSend);
      break;
    //----------------Z-axis----------------
    case 6:
      AccelStepperZ.setCurrentPosition(0);
      AccelStepperZ.setMaxSpeed(speedZ);
      AccelStepperZ.setAcceleration(speedZ / 2);
      AccelStepperZ.moveTo(-9999999);
      buttonState = digitalRead(inputpin);

      while (buttonState == 0) {
        buttonState = digitalRead(inputpin);
        AccelStepperZ.run();

      }
      AccelStepperZ.stop();
      AccelStepperZ.setCurrentPosition(0);
      AccelStepperZ.moveTo(backoffdistance);
      AccelStepperZ.run();

      while (AccelStepperZ.currentPosition() != AccelStepperZ.targetPosition()) {

        AccelStepperZ.run();

      }
      AccelStepperZ.setCurrentPosition(0);
      AccelStepperZ.run();
      StringSend = "#refPosZ_1$";
      Serial5.print(StringSend);
      break;


  }



}
